class InstructionBlock

	def is_cond_block
		return if @list.empty?
		opcode = @list.last.opcode
		opcode.props[:setip] and not opcode.props[:stopexec]
	end
	
end



class MyExc < RuntimeError ; end


	
class CPU
	
	@@eflags = [ :eflag_z, :eflag_s, :eflag_c, :eflag_o]
	
	def get_eflags_r(dasm, di)
		b = di.backtrace_binding ||= backtrace_binding(di)
		b.values.map{|effect|
			Expression[effect].externals
		}.flatten	& @@eflags
	end
	
	def get_eflags_w(dasm, di)
		b = di.backtrace_binding ||= backtrace_binding(di)
		b.keys & @@eflags
	end	
	
end



class Disassembler
	
	# hash addr => DecodedInstruction
	attr_accessor :pre_decoded
	
	def include_func_proto(addr, symbolName)
		@function[addr] = @cpu.decode_c_function_prototype(@c_parser, @c_parser.toplevel.symbol[symbolName])
		auto_label_at(addr, symbolName)		
	end
	
	def cache_disasm
		@pre_decoded = @decoded.clone()
	end
	
	def restore_disasm
		@decoded = @pre_decoded.clone()
	end
	
end

		
